# Project View

If no machine or no project has been opened, the Project View will allow you to create a project. If you choose to open a machine without having a project, a default project will be created.

The Project View contains several tabs:
* __Machines__, containing machines added to this project
* __Status__, containing the verification status of each machine
* __Preferences__, containing custom preferences
* __Project__, containing name and description

## <a id="Machines"> Machines Tab </a>

![Machines Tab](../screenshots/Project/Machines%20Tab.png)

This tab shows the machines belonging to the project. By using the plus button several machines can be added to the project. By clicking right on a specific machine this machine can be edited or removed from the project.

## <a id="Verifications"> Status Tab </a>

![Status Tab](../screenshots/Project/Verifications%20Tab.png)

This tab shows the status of each type of verification run on the machines contained by the project. If no test of a specific verification type has been run, a blue questionmark sign is shown. If the verification type could not recognize any failures, a green check will be displayed. If a test failed, a red x sign will be shown.

## <a id="Preferences"> Preferences Tab </a>

![Preferences Tab](../screenshots/Project/Preferences%20Tab.png)

This tab allows to add, edit and remove preference settings and shows a list of these preference settings by the names chosen by the user. By pressing the plus button you can add and by right clicking on a specific preference setting you can edit and remove.

![Add Preference](../screenshots/Project/Add%20Preference.png)

The screenshot above shows the window for adding and editing preferences.

## <a id="Project"> Project Tab </a>

![Project Tab](../screenshots/Project/Project%20Tab.png)

This tab shows the name and the description of the current project. Both are either automatically generated by opening a machine or chosen by the user who manually created the project and can be changed by double clicking on each respectively.
